/*
 *	@(#)Canvas2D.java 1.5 00/02/10 13:13:48
 *
 * Copyright (c) 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/**
 * Class:       Canvas2D
 *
 * Description: Used to respond to mouse events in the 2D window.
 *
 * Version:     1.0
 *
 */
class Canvas2D extends Canvas implements MouseListener {

   Image backbuffer;          // Backbuffer image
   Graphics gc;               // Graphics context of backbuffer
   Board board;               // Game board

   Canvas2D(Board board) {
      this.board = board;
   }

   public void setBuffer(Image backbuffer) {
      this.backbuffer = backbuffer;
      gc = backbuffer.getGraphics();
   }

   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      if (board != null) {
         board.render2D(gc);
         g.drawImage(backbuffer, 0, 0, this);
      }
   }

   public void mousePressed(MouseEvent e) {
      board.checkSelection2D(e.getX(), e.getY(), 1);
      repaint();
   }

   public void mouseClicked(MouseEvent  e) {}
   public void mouseReleased(MouseEvent e) {}
   public void mouseEntered(MouseEvent  e) {}
   public void mouseExited(MouseEvent   e) {}
}
